/*
 * ThreadLifetime class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util.lifetime;

/**
 * スレッドの終了に合わせて生存期間を決定する{@link ts.util.lifetime.Lifetime
 * Lifetime}クラス。
 * <br>
 * 指定された{@link java.lang.Thread Thread}オブジェクトの終了を検知して、
 * 格納している{@link ts.util.lifetime.Life}オブジェクトの
 * {@link ts.util.lifetime.Life#willDie() willDie()}メソッドを呼び出す。
 *
 * @author  佐藤隆之.
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:48 $
 */
public class ThreadLifetime extends Lifetime
{
  /**
   * デフォルトコンストラクタ。
   */
  public ThreadLifetime()
  {}

  /**
   * 生存期間を決定する{@link java.lang.Thread Thread}オブジェクトを設定する。
   *
   * @param  thread 生存期間を決定する{@link java.lang.Thread Thread}
   *           オブジェクト。
   * @throws AssertionError 引数がヌルの場合（デバッグ・モードのみ）。
   */
  public void setLifeLong(final Thread thread)
  {
    Thread notifyThread = new Thread() {
      public void run() {
        try {
          thread.join();
          threadEnded(thread);
        }
        catch (Exception e) {
          catchThreadException(e, thread);
        }
        finally {
          kill();
        }
      }
    };
    notifyThread.start();
  }

  /**
   * スレッドが終了した後に呼び出されるメソッド。
   * <br>
   * スレッドの終了時に何らかの処理を実行したい場合は、このオブジェクトを
   * オーバーライドする。
   * <br>
   * このクラスでは何もしない。
   *
   * @param  thread スレッド・オブジェクト。
   */
  protected void threadEnded(Thread thread)
  {}

  /**
   * スレッドの終了を待っている間に例外が発生した場合に、その例外を受け取る。
   * <br>
   * 例外が発生した際に何らかの処理を行いたい場合ば、このメソッドを
   * オーバーライドする。
   * <br>
   * このメソッドでは何もしない。
   *
   * @param  exc 発生した例外。
   * @param  thread スレッド・オブジェクト。
   */
  protected void catchThreadException(Exception exc, Thread thread)
  {}
}

